<?php

class cp_skin_lookandfeel {

var $ipsclass;


//===========================================================================
// LOOK AND FEEL: TEMPLATES
//===========================================================================
function template_bits_bit_row_image( $id, $image ) {

$IPBHTML = "";
//--starthtml--//

$IPBHTML .= <<<EOF
<img id='img-item-{$id}' src='{$this->ipsclass->skin_url}/images/{$image}' border='0' alt='' />
EOF;

//--endhtml--//
return $IPBHTML;
}

//===========================================================================
// LOOK AND FEEL: TEMPLATES
//===========================================================================
function template_bits_overview_row_normal( $group, $folder_blob, $count_string ) {

$IPBHTML = "";
//--starthtml--//

$IPBHTML .= <<<EOF
<div class='tablerow1' id='dv-{$group['group_name']}'>
 <div style='float:right'>
  ($count_string)&nbsp;{$group['easy_preview']}
 </div>
 <div align='left'>
   <img src='{$this->ipsclass->skin_url}/images/folder.gif' alt='Template Group' style='vertical-align:middle' />
   {$folder_blob}&nbsp;<a style='font-size:11px' id='gn-{$group['group_name']}' onclick='template_load_bits("{$group['group_name']}", event)' title='{$group['easy_desc']}' href='{$this->ipsclass->base_url}&{$this->ipsclass->form_code}&code=template-bits-list&id={$group['_id']}&p={$group['_p']}&group_name={$group['group_name']}'>{$group['easy_name']}</a>
   <span id='match-{$group['group_name']}'></span>
 </div>
</div>
EOF;

//--endhtml--//
return $IPBHTML;
}

//===========================================================================
// LOOK AND FEEL: TEMPLATES
//===========================================================================
function template_bits_bit_row( $sec, $custom_bit, $remove_button, $altered_image ) {

$IPBHTML = "";
//--starthtml--//

$IPBHTML .= <<<EOF
<div class='tablerow1' id='dvb-{$sec['func_name']}' title='       ' onclick='parent.template_toggle_bit_row("{$sec['func_name']}")' >
 <div style='float:right;width:auto;'>
  $remove_button
  <a style='text-decoration:none' title='   ' href='#' onclick='pop_win("act=rtempl&code=preview&suid={$sec['suid']}&type=text"); parent.template_cancel_bubble( event, true );'><img src='{$this->ipsclass->skin_url}/images/te_text.gif' border='0' alt='   '></a>
  <a style='text-decoration:none' title='   HTML' href='#' onclick='pop_win("act=rtempl&code=preview&suid={$sec['suid']}&type=css");  parent.template_cancel_bubble( event, true );'><img src='{$this->ipsclass->skin_url}/images/te_html.gif' border='0' alt='   HTML'>&nbsp;</a>
 </div>
 <div align='left'>
   <img src='{$this->ipsclass->skin_url}/images/file.gif' title='Template Set:{$sec['set_id']}' alt='' style='vertical-align:middle' />
   {$altered_image}
   <a id='bn-{$sec['func_name']}' onclick='parent.template_load_editor("{$sec['func_name']}", event)' href='{$this->ipsclass->base_url}&{$this->ipsclass->form_code}&code=template-edit-bit&bitname={$sec['func_name']}&p={$sec['_p']}&id={$sec['_id']}&group_name={$sec['group_name']}&type=single' title=' : {$sec['func_name']}'>{$sec['easy_name']}</a>
   {$custom_bit}
 </div>
</div>
EOF;

//--endhtml--//
return $IPBHTML;
}

//===========================================================================
// LOOK AND FEEL: TEMPLATES
//===========================================================================
function template_bits_bit_overview( $group, $content, $add_button ) {

$IPBHTML = "";
//--starthtml--//

$IPBHTML .= <<<EOF
<div class='tablerow3'>
 <div style='float:right;padding-top:3px'><strong>{$group['easy_name']}</strong></div>
 <div>
  <a href='#' onclick="parent.template_close_bits(); return false;" title=' '><img src='{$this->ipsclass->skin_url}/images/skineditor_close.gif' border='0' alt='' /></a>&nbsp;
  <!--<a href='#' onclick="toggleselectall(); return false;" title=' /   '><img src='{$this->ipsclass->skin_url}/images/skineditor_tick.gif' border='0' alt='/ ' /></a>-->
 </div>
</div>
<div id='template-bits-container'>
{$content}
</div>
 <div style='background:#CCC'>
   <div align='left' style='padding:5px;margin-left:25px'>
   <div style='float:right'>$add_button</div>
   <div><input type='button' onclick='parent.template_load_bits_to_edit("{$this->ipsclass->base_url}&{$this->ipsclass->form_code}&code=template-edit-bit&id={$this->ipsclass->input['id']}&p={$this->ipsclass->input['p']}&group_name={$group['group_name']}&type=multiple")' class='realbutton' value=' ' /></div>
 </div>
</div>
<script type="text/javascript">
//<![CDATA[
parent.template_bits_onload();
//]]>
</script>
EOF;

//--endhtml--//
return $IPBHTML;
}

//===========================================================================
//  LOOK AND FEEL: TEMPLATES
//===========================================================================
function template_bits_overview($content, $javascript) {

$IPBHTML = "";
//--starthtml--//

$IPBHTML .= <<<EOF
<script type="text/javascript">
//<![CDATA[
var lang_matches = "matches";
$javascript
//]]>
</script>
<script type="text/javascript" src='jscripts/ipb_xhr_findnames.js'></script>
<script type="text/javascript" src='{$this->ipsclass->skin_url}/acp_template.js'></script>
<div id='ipb-get-members' style='border:1px solid #000; background:#FFF; padding:2px;position:absolute;width:210px;display:none;z-index:10'></div>
<div class='tableborder'>
 <div class='tableheaderalt'>
  <table cellpadding='0' cellspacing='0' border='0' width='100%'>
  <tr>
  <td align='left' width='100%'>
   <div id='quick-search-box'>
    <form id='quick-search-form'>
     <input type='text' size='20' class='realwhitebutton' style='width:210px' name='searchkeywords' id='entered_template' autocomplete="off" value='' />&nbsp;<input type='button' onclick='template_find_bits(event)' class='realbutton' value='  ' />
    </form>
   </div>
  </td>
  </tr>
  </table>
</div>
   <div id='template-main-wrap'>
   <div id='template-edit' style='height:0;width:100%;display:none;z-index:1'><iframe id='te-iframe' name='te-iframe' onload='template_iframe_loaded( "te" )' style='width:0;height:0px;display:none' src='javascript:;'></iframe></div>
   <div id='template-bits' style='float:right;width:0;display:none;z-index:2'><iframe id='tb-iframe' name='tb-iframe' onload='template_iframe_loaded( "tb" )' style='width:0;height:0px;display:none' src='javascript:;'></iframe></div>
   <div id='template-sections' style='width:100%;overflow:auto;height:475px;z-index:3;'>
	 $content
   </div>
 </div>
 <div align='center' class='tablefooter'><!--hehe-->&nbsp;</div>
</div>
<br clear='all' />
<br />
<div><strong>:</strong><br />
<img id='img-altered' src='{$this->ipsclass->skin_url}/images/skin_item_altered.gif' border='0' alt='+' title='    ' />     .
<br /><img id='img-unaltered' src='{$this->ipsclass->skin_url}/images/skin_item_unaltered.gif' border='0' alt='-' title='     ' />      .
<br /><img id='img-inherited' src='{$this->ipsclass->skin_url}/images/skin_item_inherited.gif' border='0' alt='|' title='    ' />     .
</div>
<script type='text/javascript'>
//<![CDATA[
// INIT images
img_revert_blank = '{$this->ipsclass->skin_url}/images/blank.gif';
img_revert_real  = '{$this->ipsclass->skin_url}/images/te_revert.gif';
img_revert_width  = 44;
img_revert_height = 16;

template_init();
// INIT find names
init_js( 'quick-search-form', 'entered_template', 'get-template-names&id={$this->ipsclass->input['id']}' );
// Run main loop
setTimeout( 'main_loop()', 10 );
//]]>
</script>
EOF;

//--endhtml--//
return $IPBHTML;
}


//===========================================================================
//  LOOK AND FEEL: TEMPLATES
//===========================================================================
function skin_sets_overview($content) {

$IPBHTML = "";
//--starthtml--//

$IPBHTML .= <<<EOF
<div class='tableborder'>
 <div class='tableheaderalt'>
 <table cellpadding='0' cellspacing='0' border='0' width='100%'>
 <tr>
  <td align='left' width='95%' style='font-size:12px; vertical-align:middle;font-weight:bold; color:#FFF;'></td>
  <td align='right' width='5%' nowrap='nowrap'>
   <img id="menumainone" src='{$this->ipsclass->skin_url}/images/filebrowser_action.gif' border='0' alt='' class='ipd' />
 </td>
 </tr>
</table>
 </div>
 <table cellpadding='0' cellspacing='0' width='100%'>
 $content
 </table>
 <div align='center' class='tablefooter'>&nbsp;</div>
</div>
<br />
<div><strong>:</strong><br />
<img src='{$this->ipsclass->skin_url}/images/skin_item_altered.gif' border='0' alt='+' title='    ' />     .
<br /><img src='{$this->ipsclass->skin_url}/images/skin_item_unaltered.gif' border='0' alt='-' title='     ' />      .
<br /><img src='{$this->ipsclass->skin_url}/images/skin_item_inherited.gif' border='0' alt='|' title='    ' />     .
</div>
EOF;
if ( IN_DEV == 1 )
{
$IPBHTML .= <<<EOF
<br />
<div align='center'>
  DEV: <a href='{$this->ipsclass->base_url}&{$this->ipsclass->form_code}&code=exportmaster'> HTML  </a>
  &middot; <a href='{$this->ipsclass->base_url}&{$this->ipsclass->form_code}&code=exportbitschoose'> </a>
  &middot; <a href='{$this->ipsclass->base_url}&{$this->ipsclass->form_code}&code=exportmacro'>   </a>
</div>
EOF;
}
$IPBHTML .= <<<EOF
<script type="text/javascript">
  menu_build_menu(
  "menumainone",
  new Array( 
  			 "<form action='{$this->ipsclass->base_url}&{$this->ipsclass->form_code}&code=addset&id=-1' method='POST'><div align='center'><strong>  </strong></div>",
  			 "<div align='center'><input type='text' name='set_name' size='20' value='  ' onfocus='this.value=\"\"'></center></div>",
  			 "<div align='center'><input type='submit' value='' class='realdarkbutton' /></div></form>"
           ) );
</script>
EOF;

//--endhtml--//
return $IPBHTML;
}

//===========================================================================
// LOOK AND FEEL: TEMPLATES
//===========================================================================
function skin_sets_overview_row( $r, $forums, $hidden, $default, $menulist, $i_sets, $no_sets, $folder_icon, $line_image, $css_extra ) {

$IPBHTML = "";
//--starthtml--//

$IPBHTML .= <<<EOF
<tr>
 <td class='tablerow1'>
   <!--$i_sets,$no_sets-->{$line_image}<!--ID:{$r['set_skin_set_id']}--><img src='{$this->ipsclass->skin_url}/images/{$folder_icon}' border='0' alt='' style='vertical-align:middle' />
   <strong style='{$css_extra}'>{$r['set_name']}</strong>
 </td>
 <td class='tablerow1' width='5%' nowrap='nowrap' align='center'>{$forums} {$hidden} {$default}</td>
 <td class='tablerow1' width='5%'><img id="menu{$r['set_skin_set_id']}" src='{$this->ipsclass->skin_url}/images/filebrowser_action.gif' border='0' alt='' class='ipd' /></td>
</tr>
<script type="text/javascript">
  menu_build_menu(
  "menu{$r['set_skin_set_id']}",
  new Array(
			$menulist
  		    ) );
 </script>
EOF;

//--endhtml--//
return $IPBHTML;
}

//===========================================================================
// LOOK AND FEEL: TEMPLATES
//===========================================================================
function skin_sets_overview_row_menulist( $r ) {

$IPBHTML = "";
//--starthtml--//

$IPBHTML .= <<<EOF
img_item   + " <!--ALTERED.wrappper--><a href='{$this->ipsclass->base_url}&section={$this->ipsclass->section_code}&act=wrap&code=edit&id={$r['set_skin_set_id']}&p={$r['set_skin_set_parent']}'>   </a>",
img_item   + " <!--ALTERED.templates--><a href='{$this->ipsclass->base_url}&section={$this->ipsclass->section_code}&act=templ&code=template-sections-list&id={$r['set_skin_set_id']}&p={$r['set_skin_set_parent']}'> HTML </a>",
img_item   + " <!--ALTERED.css--><a href='{$this->ipsclass->base_url}&section={$this->ipsclass->section_code}&act=style&code=edit&id={$r['set_skin_set_id']}&p={$r['set_skin_set_parent']}'> CSS  ( )</a>",
img_item   + " <!--ALTERED.css--><a href='{$this->ipsclass->base_url}&section={$this->ipsclass->section_code}&act=style&code=colouredit&id={$r['set_skin_set_id']}&p={$r['set_skin_set_parent']}'> CSS  ( ) -  </a>",
img_item   + " <!--ALTERED.macro--><a href='{$this->ipsclass->base_url}&section={$this->ipsclass->section_code}&act=image&code=edit&id={$r['set_skin_set_id']}&p={$r['set_skin_set_parent']}'> </a>",
img_item   + " <a href='{$this->ipsclass->base_url}&{$this->ipsclass->form_code}&code=edit&id={$r['set_skin_set_id']}'> ...</a>",
EOF;
if ( $r['set_skin_set_id'] != 1 )
{
$IPBHTML .= <<<EOF

img_item   + " <a href='{$this->ipsclass->base_url}&{$this->ipsclass->form_code}&code=revertallform&id={$r['set_skin_set_id']}'>   ...</a>",
img_item   + " <a href='{$this->ipsclass->base_url}&section={$this->ipsclass->section_code}&act=import&code=showexportpage&id={$r['set_skin_set_id']}'> ...</a>",
img_item   + " <a href='{$this->ipsclass->base_url}&section={$this->ipsclass->section_code}&act=skindiff&code=skin_diff_from_skin&skin_id={$r['set_skin_set_id']}'>   ...</a>",
img_item   + " <a href='{$this->ipsclass->base_url}&{$this->ipsclass->form_code}&code=remove&id={$r['set_skin_set_id']}'> ...</a>",
EOF;
}
if ( $r['set_skin_set_id'] != 1 AND ! $r['set_skin_set_parent'] )
{
$IPBHTML .= <<<EOF

img_item   + " <a  href='#' onclick=\"addnewpop('{$r['set_skin_set_id']}','menu_{$r['set_skin_set_id']}')\">    </a>",
EOF;
}

//--endhtml--//
return $IPBHTML;
}

//===========================================================================
//  LOOK AND FEEL: SKIN DIFF: MAIN
//===========================================================================
function skin_diff_main_overview($content) {

$IPBHTML = "";
//--starthtml--//

$IPBHTML .= <<<EOF
<script type="text/javascript" src='{$this->ipsclass->skin_url}/acp_template.js'></script>
<div class='tableborder'>
 <div class='tableheaderalt'>
 <table cellpadding='0' cellspacing='0' border='0' width='100%'>
 <tr>
  <td align='left' width='95%' style='font-size:12px; vertical-align:middle;font-weight:bold; color:#FFF;'>  </td>
 </tr>
</table>
 </div>
 <table cellpadding='0' cellspacing='0' width='100%'>
 <tr>
  <td class='tablesubheader' width='90%'><strong></strong></td>
  <td class='tablesubheader' width='5%'></a>
  <td class='tablesubheader' width='5%'>&nbsp;</a>
 </tr>
 $content
 </table>
 <div align='right' class='tablefooter'>&nbsp;</div>
</div>
<br />
<form action='{$this->ipsclass->base_url}&amp;{$this->ipsclass->form_code}&amp;code=skin_diff' enctype='multipart/form-data' method='POST'>
<div class='tableborder'>
 <div class='tableheaderalt'>    </div>
 <table cellpadding='0' cellspacing='0' border='0' width='100%'>
 <tr>
  <td class='tablerow1'><strong> </strong><div class='desctext'>      ,    </div></td>
  <td class='tablerow2'><input class='textinput' type='text' size='30' name='diff_session_title' /></td>
 </tr>
 <tr>
  <td class='tablerow1'><strong>  / ?</strong><div class='desctext'>    ipb_templates.xml    IPB,     .     XML    ,     .</div></td>
  <td class='tablerow2'><input class='textinput' type='checkbox' value='1' name='diff_session_ignore_missing' /></td>
 </tr>
 <tr>
  <td class='tablerow1'><strong>   ipb_templates.xml.</strong><div class='desctext'>    HTML   </div></td>
  <td class='tablerow2'><input class='textinput' type='file' size='30' name='FILE_UPLOAD' /></td>
 </tr>
 </table>
 <div align='center' class='tablefooter'><input type='submit' class='realbutton' value='' /></div>
</div>
</form>
EOF;

//--endhtml--//
return $IPBHTML;
}

//===========================================================================
// LOOK AND FEEL: TEMPLATES
//===========================================================================
function skin_diff_main_row( $data ) {

$IPBHTML = "";
//--starthtml--//

$IPBHTML .= <<<EOF
<tr>
 <td class='tablerow1'> <strong>{$data['diff_session_title']}</strong></td>
 <td class='tablerow1' width='5%' nowrap='nowrap' align='center'>{$data['_date']}</td>
 <td class='tablerow1' width='5%'><img id="menu{$data['diff_session_id']}" src='{$this->ipsclass->skin_url}/images/filebrowser_action.gif' border='0' alt='' class='ipd' /></td>
</tr>
<script type="text/javascript">
  menu_build_menu(
  "menu{$data['diff_session_id']}",
  new Array(
			img_item   + " <a href='{$this->ipsclass->base_url}&amp;{$this->ipsclass->form_code}&amp;code=skin_diff_view&amp;diff_session_id={$data['diff_session_id']}'>  ...</a>",
			img_item   + " <a href='#' onclick=\"checkdelete('{$this->ipsclass->form_code}&code=skin_diff_remove&diff_session_id={$data['diff_session_id']}')\">  ...</a>",
			img_item   + " <a href='{$this->ipsclass->base_url}&amp;{$this->ipsclass->form_code}&amp;code=skin_diff_export&amp;diff_session_id={$data['diff_session_id']}'> HTML ...</a>"
  		    ) );
 </script>
EOF;

//--endhtml--//
return $IPBHTML;
}


//===========================================================================
//  LOOK AND FEEL: SKIN DIFF
//===========================================================================
function skin_diff_overview($content, $missing, $changed) {

$IPBHTML = "";
//--starthtml--//

$IPBHTML .= <<<EOF
<script type="text/javascript" src='{$this->ipsclass->skin_url}/acp_template.js'></script>
<div class='tableborder'>
 <div class='tableheaderalt'>
 <table cellpadding='0' cellspacing='0' border='0' width='100%'>
 <tr>
  <td align='left' width='95%' style='font-size:12px; vertical-align:middle;font-weight:bold; color:#FFF;'> </td>
  <td align='right' width='5%' nowrap='nowrap'>
  &nbsp;
 </td>
 </tr>
</table>
 </div>
 <table cellpadding='0' cellspacing='0' width='100%'>
 <tr>
  <td class='tablesubheader' width='90%'><strong> </strong></td>
  <td class='tablesubheader' width='5%'></a>
  <td class='tablesubheader' width='5%'></a>
  <td class='tablesubheader' width='5%'>&nbsp;</a>
 </tr>
 $content
 </table>
 <div align='right' class='tablefooter'>$missing    $changed </div>
</div>
EOF;

//--endhtml--//
return $IPBHTML;
}

//===========================================================================
// LOOK AND FEEL: TEMPLATES: NEW GROUP
//===========================================================================
function skin_diff_row_newgroup( $group_name ) {

$IPBHTML = "";
//--starthtml--//

$IPBHTML .= <<<EOF
<tr>
 <td colspan='4' class='tablerow3'>
   <strong>{$group_name}</strong>
 </td>
EOF;

//--endhtml--//
return $IPBHTML;
}

//===========================================================================
// LOOK AND FEEL: TEMPLATES
//===========================================================================
function skin_diff_row( $template_bit_name, $template_bit_size, $template_bit_id, $diff_is, $template_bit_id_safe ) {

$IPBHTML = "";
//--starthtml--//

$IPBHTML .= <<<EOF
<tr>
 <td class='tablerow1'>
   <strong>{$template_bit_name}</strong>
 </td>
 <td class='tablerow1' width='5%' nowrap='nowrap' align='center'>{$diff_is}</td>
 <td class='tablerow1' width='5%' nowrap='nowrap' align='center'>{$template_bit_size}</td>
 <td class='tablerow1' width='5%'><img id="menu{$template_bit_id_safe}" src='{$this->ipsclass->skin_url}/images/filebrowser_action.gif' border='0' alt='' class='ipd' /></td>
</tr>
<script type="text/javascript">
  menu_build_menu(
  "menu{$template_bit_id_safe}",
  new Array(
			img_item   + " <a href='#' onclick=\"return template_view_diff('$template_bit_id')\"> ...</a>"
  		    ) );
 </script>
EOF;

//--endhtml--//
return $IPBHTML;
}

//===========================================================================
// LOOK AND FEEL: TEMPLATES
//===========================================================================
function skin_diff_view_bit( $template_bit_name, $template_group, $content ) {

$IPBHTML = "";
//--starthtml--//

$IPBHTML .= <<<EOF
<div style='padding:4px;border:1px solid #000;background-color:#FFF;margin:4px;'>
<strong>$template_group &gt; $template_bit_name</strong>
</div>
<div style='padding:4px;border:1px solid #000;background-color:#FFF;margin:4px;'>
<pre>
$content
</pre>
</div>
<div style='padding:4px;border:1px solid #000;background-color:#FFF;margin:4px;'>
 <span class='diffred'> HTML </span> &middot; <span class='diffgreen'> HTML </span>
</div>
EOF;

//--endhtml--//
return $IPBHTML;
}


//===========================================================================
// LOOK AND FEEL: TEMPLATES
//===========================================================================
function skin_diff_export_row( $func_name, $func_group, $content ) {

$IPBHTML = "";
//--starthtml--//

$IPBHTML .= <<<EOF
<div style='padding:4px;border:1px solid #000;background-color:#FFF;margin:4px;'>
<h2>$func_group <span style='color:green'>&gt;</span> $func_name</h2>
<hr>
<pre>
$content
</pre>
</div>
EOF;

//--endhtml--//
return $IPBHTML;
}


//===========================================================================
// LOOK AND FEEL: TEMPLATES
//===========================================================================
function skin_diff_export_overview( $content, $missing, $changed, $title, $date ) {

$IPBHTML = "";
//--starthtml--//

$IPBHTML .= <<<EOF
<html>
 <head>
  <title>$title export</title>
  <style type="text/css">
   BODY
   {
   	font-family: verdana;
   	font-size:11px;
   	color: #000;
   	background-color: #CCC;
   }
   
   del,
   .diffred
   {
	   background-color: #D7BBC8;
	   text-decoration:none;
   }
   
   ins,
   .diffgreen
   {
	   background-color: #BBD0C8;
	   text-decoration:none;
   }
   
   h1
   {
   	font-size: 18px;
   }
   
   h2
   {
   	font-size: 18px;
   }
  </style>
 </head>
<body>
  <div style='padding:4px;border:1px solid #000;background-color:#FFF;margin:4px;'>
  <h1>$title (: $date)</h1>
  <strong>$missing    $changed </strong>
  </div>
  <br />
  $content
  <br />
  <div style='padding:4px;border:1px solid #000;background-color:#FFF;margin:4px;'>
   <span class='diffred'> HTML </span> &middot; <span class='diffgreen'> HTML </span>
  </div>
</body>
<html>
EOF;

//--endhtml--//
return $IPBHTML;
}

}


?>