<?php

/*
+--------------------------------------------------------------------------
|   Invision Power Board v2.1.6
|   =============================================
|   by Matthew Mecham
|   (c) 2001 - 2004 Invision Power Services, Inc.| http://www.ws.ea7.net & http://wowdesign.com.ua/
|   =============================================| Web: http://www.ws.ea7.net & http://wowdesign.com.ua/
|   Time: Thu, 22 Sep 2005 17:29:55 GMT
|   Release: 9e54998709cdf031b7543ccdc0a9dfd7| Licence Info: http://www.ws.ea7.net & http://wowdesign.com.ua/
+---------------------------------------------------------------------------
|
|   > Help Control functions
|   > Module written by Matt Mecham
|   > Date started: 2nd April 2002
|
|	> Module Version Number: 1.0.0
|   > DBA Checked: Mon 24th May 2004
+--------------------------------------------------------------------------
|        Jax ( NewAge.gcnet.ru )
|      IBResource.ru
|    : , 2005 
+--------------------------------------------------------------------------
*/

if ( ! defined( 'IN_ACP' ) )
{
	print "<h1> </h1>        .    , ,     'admin.php'.";
	exit();
}


class ad_help
{
	var $base_url;
	
	/**
	* Section title name
	*
	* @var	string
	*/
	var $perm_main = "tools";
	
	/**
	* Section title name
	*
	* @var	string
	*/
	var $perm_child = "help";
	
	function auto_run()
	{
		//-----------------------------------------
		// Kill globals - globals bad, Homer good.
		//-----------------------------------------
		
		$tmp_in = array_merge( $_GET, $_POST, $_COOKIE );
		
		foreach ( $tmp_in as $k => $v )
		{
			unset($$k);
		}
		
		//-----------------------------------------

		switch($this->ipsclass->input['code'])
		{
			case 'edit':
				$this->ipsclass->admin->cp_permission_check( $this->perm_main.'|'.$this->perm_child.':edit' );
				$this->show_form('edit');
				break;
			case 'new':
				$this->ipsclass->admin->cp_permission_check( $this->perm_main.'|'.$this->perm_child.':add' );
				$this->show_form('new');
				break;
			
			case 'doedit':
				$this->ipsclass->admin->cp_permission_check( $this->perm_main.'|'.$this->perm_child.':edit' );
				$this->doedit();
				break;
				
			case 'donew':
				$this->ipsclass->admin->cp_permission_check( $this->perm_main.'|'.$this->perm_child.':add' );
				$this->doadd();
				break;
				
			case 'remove':
				$this->ipsclass->admin->cp_permission_check( $this->perm_main.'|'.$this->perm_child.':remove' );
				$this->remove();
				break;
			
			//-----------------------------------------
			default:
				$this->ipsclass->admin->cp_permission_check( $this->perm_main.'|'.$this->perm_child.':' );
				$this->list_files();
				break;
		}
		
	}
	
	//-----------------------------------------
	// HELP FILE FUNCTIONS
	//-----------------------------------------
	
	function doedit()
	{
		if ($this->ipsclass->input['id'] == "")
		{
			$this->ipsclass->admin->error("    ID  !");
		}
		
		$text  = preg_replace( "/\n/", "<br>", stripslashes($_POST['text'] ) );
		//$title = preg_replace( "/\n/", "<br>", stripslashes($_POST['title'] ) );
		$desc  = preg_replace( "/\n/", "<br>", stripslashes($_POST['description'] ) );
		
		$text  = preg_replace( "/\\\/", "&#092;", $text );
		
		$this->ipsclass->DB->do_update( 'faq', array( 'title'       => $this->ipsclass->input['title'],
													  'text'        => $text,
													  'description' => $desc,
											 ) , "id=".intval($this->ipsclass->input['id'])     );
		
		$this->ipsclass->admin->save_log("  ");
		
		$this->ipsclass->boink_it($this->ipsclass->base_url."&{$this->ipsclass->form_code}");
		exit();
			
		
	}
	
	//=====================================================
	
	
	function show_form($type='new')
	{
		$this->ipsclass->admin->page_detail = "     ,     .";
		$this->ipsclass->admin->page_title  = "  ";
		
		//-----------------------------------------
		
		if ($type != 'new')
		{
		
			if ($this->ipsclass->input['id'] == "")
			{
				$this->ipsclass->admin->error("    ID  !");
			}
		
			//-----------------------------------------
			
			$this->ipsclass->DB->simple_construct( array( 'select' => '*', 'from' => 'faq', 'where' => "id=".intval($this->ipsclass->input['id']) ) );
			$this->ipsclass->DB->simple_exec();
		
			if ( ! $r = $this->ipsclass->DB->fetch_row() )
			{
				$this->ipsclass->admin->error("         ID");
			}
		
			//-----------------------------------------
			
			$button = '   ';
			$code   = 'doedit';
		}
		else
		{
			$r = array();
			$button = '   ';
			$code   = 'donew';
		}
		
		$this->ipsclass->html .= $this->ipsclass->adskin->start_form( array( 1 => array( 'code'  , $code ),
																			 2 => array( 'act'   , 'help'     ),
																			 3 => array( 'id'    , $this->ipsclass->input['id'] ),
																			 4 => array( 'section', $this->ipsclass->section_code ),
																	)      );
		
		
		
		$this->ipsclass->adskin->td_header[] = array( "&nbsp;"  , "20%" );
		$this->ipsclass->adskin->td_header[] = array( "&nbsp;"  , "80%" );
		
		$r['text'] = preg_replace( "/<br>/i", "\n", stripslashes($r['text']) );
 		
 		//-----------------------------------------
		
		$this->ipsclass->html .= $this->ipsclass->adskin->start_table( $button );
		
		
		$this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "  ",
												  $this->ipsclass->adskin->form_input('title'  , stripslashes($r['title']) ),
										 )      );
										 
		$this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "",
												  $this->ipsclass->adskin->form_textarea('description', stripslashes($r['description']) ),
										 )      );
										 
		$this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "",
												  $this->ipsclass->adskin->form_textarea('text', $r['text'], "60", "10" ),
										 )      );
										 
		$this->ipsclass->html .= $this->ipsclass->adskin->end_form($button);
										 
		$this->ipsclass->html .= $this->ipsclass->adskin->end_table();
		
		$this->ipsclass->admin->output();
	
	}
	
	//=====================================================
	
	function remove()
	{
		if ($this->ipsclass->input['id'] == "")
		{
			$this->ipsclass->admin->error("    ID  !");
		}
		
		$this->ipsclass->DB->simple_exec_query( array( 'delete' => 'faq', 'where' => "id=".$this->ipsclass->input['id'] ) );
	
		$this->ipsclass->admin->save_log("Removed a help file");
		
		$this->ipsclass->boink_it($this->ipsclass->base_url."&{$this->ipsclass->form_code}");
		exit();
			
		
	}
	
	//=====================================================
	
	function doadd()
	{
		if ($this->ipsclass->input['title'] == "")
		{
			$this->ipsclass->admin->error("     !");
		}
		
		
		
		$text  = preg_replace( "/\n/", "<br>", stripslashes($_POST['text'] ) );
		$title = preg_replace( "/\n/", "<br>", stripslashes($_POST['title'] ) );
		$desc  = preg_replace( "/\n/", "<br>", stripslashes($_POST['description'] ) );
		
		$text  = preg_replace( "/\\\/", "&#092;", $text );
		
		$this->ipsclass->DB->do_insert( 'faq', array( 'title'       => $title,
									  'text'        => $text,
									  'description' => $desc,
							 )      );
												  
		$this->ipsclass->admin->save_log("  ");
		
		$this->ipsclass->boink_it($this->ipsclass->base_url."&{$this->ipsclass->form_code}");
		exit();
			
		
	}
	
	//=====================================================
	
	function list_files()
	{
		$this->ipsclass->admin->page_detail = "     ,     ";
		$this->ipsclass->admin->page_title  = "  ";
		
		//-----------------------------------------
		
		$this->ipsclass->adskin->td_header[] = array( ""  , "50%" );
		$this->ipsclass->adskin->td_header[] = array( ""   , "30%" );
		$this->ipsclass->adskin->td_header[] = array( "" , "20%" );
		
		//-----------------------------------------
		
		$this->ipsclass->html .= $this->ipsclass->adskin->start_table( "  " );
		
		$this->ipsclass->DB->simple_construct( array( 'select' => '*', 'from' => 'faq', 'order' => "id" ) );
		$this->ipsclass->DB->simple_exec();
		
		if ( $this->ipsclass->DB->get_num_rows() )
		{
			while ( $r = $this->ipsclass->DB->fetch_row() )
			{
				
				$this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( "<b>".stripslashes($r['title'])."</b><br>".stripslashes($r['description']),
														  "<center><a href='".$this->ipsclass->base_url."&{$this->ipsclass->form_code}&code=edit&id={$r['id']}'></a></center>",
														  "<center><a href='".$this->ipsclass->base_url."&{$this->ipsclass->form_code}&code=remove&id={$r['id']}'></a></center>",
												 )      );
												   
			
				
			}
		}
		
		$this->ipsclass->html .= $this->ipsclass->adskin->add_td_basic("<a href='".$this->ipsclass->base_url."&{$this->ipsclass->form_code}&code=new'>   </a>", "center", "pformstrip" );
		
		$this->ipsclass->html .= $this->ipsclass->adskin->end_table();
		
		//-----------------------------------------
		
		$this->ipsclass->admin->output();
	
	}
	
	
}


?>