<?php

/*
+--------------------------------------------------------------------------
|   Invision Power Board v2.1.6
|   ========================================
|   by Matthew Mecham
|   (c) 2001 - 2004 Invision Power Services
| http://www.ws.ea7.net & http://wowdesign.com.ua/
|   ========================================
| Web: http://www.ws.ea7.net & http://wowdesign.com.ua/
|   Time: Sun, 09 Oct 2005 11:51:26 GMT
|   Release: 1a47e28f0443faa9f14d0c0a45151e54
|   Email: matt
| Licence Info: http://www.ws.ea7.net & http://wowdesign.com.ua/
+---------------------------------------------------------------------------
|
|   > IPB UPGRADE MODULE:: IPB 2.0.2 -> IPB 2.0.3
|   > Script written by Matt Mecham
|   > Date started: 23rd April 2004
|   > "So what, pop is dead - it's no great loss.
	   So many facelifts, it's face flew off"
+--------------------------------------------------------------------------
*/

if ( ! defined( 'IN_IPB' ) )
{
	print "<h1> </h1>       .     ,      .";
	exit();
}

class version_upgrade
{
	var $this_version = '21005';
	var $upgrade_from = '21004';
	var $first_step   = '         ';
	var $md5_check    = '';
	var $base_url     = '';
	var $mod_to_run   = '';
	
	/*-------------------------------------------------------------------------*/
	// CONSTRUCTOR
	/*-------------------------------------------------------------------------*/
	
	function version_upgrade()
	{

	}
	
	function version_process()
	{		
		$this->md5_check = $this->ipsclass->return_md5_check();
		
		$this->base_url  = "index.php?act=work&loginkey={$this->ipsclass->input['loginkey']}&securekey={$this->ipsclass->input['securekey']}&mid={$this->ipsclass->input['mid']}";
		
		if ( is_array( $this->ipsclass->modules_to_run ) and count( $this->ipsclass->modules_to_run ) )
		{
			$tmp = array_shift( $this->ipsclass->modules_to_run );
			
			$this->mod_to_run = implode( ', ', $this->ipsclass->modules_to_run );
		}
		
		if ( ! $this->mod_to_run )
		{
			$this->mod_to_run = 'None';
		}
	}
	
	/*-------------------------------------------------------------------------*/
	// Auto run..
	/*-------------------------------------------------------------------------*/
	
	function auto_run()
	{
		//--------------------------------
		// What are we doing?
		// sql => DONE
		//--------------------------------
		
		switch( $this->ipsclass->input['workact'] )
		{
			case 'sql':
				$this->upgrade_sql();
				break;
			default:
				$this->upgrade_intro();
				break;
		}
	}
	

	/*-------------------------------------------------------------------------*/
	// SQL: 0
	/*-------------------------------------------------------------------------*/
	
	function upgrade_sql()
	{
		$man     = intval( $this->ipsclass->input['man'] );
		$SQL     = array();
		$file    = '_updates.php';
		$cnt     = 0;
		
		if ( file_exists( THIS_PATH . 'upg_' . $this->ipsclass->current_upgrade . '/' . strtolower($this->ipsclass->vars['sql_driver']) . $file ) )
		{
			require_once( THIS_PATH . 'upg_' . $this->ipsclass->current_upgrade . '/' . strtolower($this->ipsclass->vars['sql_driver']) . $file );
		
			foreach( $SQL as $q )
			{
				$q = str_replace( "<%time%>", time(), $q );
				
				$this->ipsclass->DB->query( $q );
				
				$cnt++;
			}
		}
		
		$this->ipsclass->core->redirect( "index.php?act=done&loginkey={$this->ipsclass->input['loginkey']}&securekey={$this->ipsclass->input['securekey']}&mid={$this->ipsclass->input['mid']}", "$cnt  ...." );
	}
	
	/*-------------------------------------------------------------------------*/
	// INTRO
	/*-------------------------------------------------------------------------*/
	
	function upgrade_intro()
	{
		$this->ipsclass->template->content .= "
			<div class='tableborder'>
			 <div class='maintitle'>     IPB</div>
			 <div class='tdrow1' style='padding:6px'>      <b>{$this->ipsclass->versions[$this->upgrade_from]}</b>  <b>{$this->ipsclass->versions[$this->this_version]}</b>
			 <br /><br />   {$this->first_step}
			 <br /><br />
			 <div align='center'><span style='font-weight:bold;font-size:14px'>&raquo; <a href='{$this->base_url}&workact=sql'>...</a></span></div>
			 </div>
			</div>
			<br />
			<div align='center'>    : {$this->mod_to_run}</div>
			";
			
		if ( ! is_writeable( CACHE_PATH . 'cache/skin_cache' ) )
		{
			$this->ipsclass->template->content .= "<div class='warnbox'><strong>:  cache/skin_cache   </strong><br />
					   ,  CHMOD   .     ,   
					     .</div>";
		}
		
		$this->ipsclass->template->output();
		
	} 
	
}
	
	
?>