<?php

/*
+--------------------------------------------------------------------------
|   Invision Power Board v2.1.6
|   ========================================
|   by Matthew Mecham
|   (c) 2001 - 2004 Invision Power Services
| http://www.ws.ea7.net & http://wowdesign.com.ua/
|   ========================================
| Web: http://www.ws.ea7.net & http://wowdesign.com.ua/
|   Time: Thu, 03 Nov 2005 17:51:02 GMT
|   Release: 21e4f66f78782ec2a8419250a5590e8d
|   Email: matt
| Licence Info: http://www.ws.ea7.net & http://wowdesign.com.ua/
+---------------------------------------------------------------------------
|
|   > IPB UPGRADE MODULE:: IPB 2.1.2 -> 2.1.3
|   > Script written by Matt Mecham
|   > Date started: 23rd April 2004
|   > "So what, pop is dead - it's no great loss.
	   So many facelifts, it's face flew off"
+--------------------------------------------------------------------------
*/

if ( ! defined( 'IN_IPB' ) )
{
	print "<h1> </h1>       .     ,      .";
	exit();
}
 

class version_upgrade
{
	var $this_version = '21009';
	var $upgrade_from = '21008';
	var $first_step   = '         ';
	var $md5_check    = '';
	var $base_url     = '';
	var $mod_to_run   = '';
	
	/*-------------------------------------------------------------------------*/
	// CONSTRUCTOR
	/*-------------------------------------------------------------------------*/
	
	function version_upgrade()
	{

	}
	
	function version_process()
	{		
		$this->md5_check = $this->ipsclass->return_md5_check();
		
		$this->base_url  = "index.php?act=work&loginkey={$this->ipsclass->input['loginkey']}&securekey={$this->ipsclass->input['securekey']}&mid={$this->ipsclass->input['mid']}";
		
		if ( is_array( $this->ipsclass->modules_to_run ) and count( $this->ipsclass->modules_to_run ) )
		{
			$tmp = array_shift( $this->ipsclass->modules_to_run );
			
			$this->mod_to_run = implode( ', ', $this->ipsclass->modules_to_run );
		}
		
		if ( ! $this->mod_to_run )
		{
			$this->mod_to_run = 'None';
		}
	}
	
	/*-------------------------------------------------------------------------*/
	// Auto run..
	/*-------------------------------------------------------------------------*/
	
	function auto_run()
	{
		//--------------------------------
		// What are we doing?
		// sql => DONE
		//--------------------------------
		
		switch( $this->ipsclass->input['workact'] )
		{
			case 'sql':
				$this->upgrade_sql();
				break;
			case 'cal':
				$this->upgrade_cal();
				break;
			case 'helpfiles':
				$this->upgrade_helpfiles();
				break;
			case 'skinrevert':
				$this->revert_skin_changes();
				break;
			default:
				$this->upgrade_intro();
				break;
		}
	}
	

	/*-------------------------------------------------------------------------*/
	// SQL: 0
	/*-------------------------------------------------------------------------*/
	
	function upgrade_sql()
	{
		$man     = intval( $this->ipsclass->input['man'] );
		$SQL     = array();
		$file    = '_updates.php';
		$cnt     = 0;
		
		if ( file_exists( THIS_PATH . 'upg_' . $this->ipsclass->current_upgrade . '/' . strtolower($this->ipsclass->vars['sql_driver']) . $file ) )
		{
			require_once( THIS_PATH . 'upg_' . $this->ipsclass->current_upgrade . '/' . strtolower($this->ipsclass->vars['sql_driver']) . $file );
		
			foreach( $SQL as $q )
			{
				$q = str_replace( "<%time%>", time(), $q );
				
				$this->ipsclass->DB->query( $q );
				
				$cnt++;
			}
		}
		
		$this->ipsclass->core->redirect( "{$this->base_url}&workact=cal",
										 "$cnt  ...." );
	}
	
	/*-------------------------------------------------------------------------*/
	// Update Old Calendar Events
	/*-------------------------------------------------------------------------*/
	
	function upgrade_cal()
	{
		$cnt     = 0;
		$outer = $this->ipsclass->DB->query( "SELECT * FROM ibf_cal_events ORDER BY event_id ASC" );
		if( $this->ipsclass->DB->get_num_rows($outer) )
		{
			while( $event = $this->ipsclass->DB->fetch_row( $outer ) )
			{
				if( $event['event_tz'] )
				{
					$this->ipsclass->DB->query( "UPDATE ibf_cal_events SET event_tz=0 WHERE event_id='{$event['event_id']}'" );
					$cnt++;
				}
			}
		}
		
		$this->ipsclass->core->redirect( "{$this->base_url}&workact=helpfiles",
										 "$cnt   ...." );
	}	
	
	/*-------------------------------------------------------------------------*/
	// Update help files
	/*-------------------------------------------------------------------------*/
	
	function upgrade_helpfiles()
	{
		if(! $this->ipsclass->input['do_update'] )
		{
			$this->ipsclass->template->content .= "
						<div class='tableborder'>
			 			<div class='maintitle'>    ?</div>
			 			<div class='tdrow1' style='padding:6px'>        .    ,    IPB 2.1.x         .
			 					      ,   ,         . 
			 					    16      .       ,   ,     ...
			 					<br /><br /><b>     ?</b>
			 			<div align='left'><blockquote><span style='font-weight:bold;font-size:14px'>&raquo; <a href='{$this->base_url}&workact=helpfiles&do_update=1'>   ...</a><br />
			 			&raquo; <a href='{$this->base_url}&workact=skinrevert'>   ...</a></span></blockquote></div>
			";
			$this->ipsclass->template->output();
		}
		else
		{
			$man     = intval( $this->ipsclass->input['man'] );
			$UPDATES     = array();
			$file    = '_updates.php';
			$cnt     = 0;
		
			if ( file_exists( THIS_PATH . 'upg_' . $this->ipsclass->current_upgrade . '/' . strtolower($this->ipsclass->vars['sql_driver']) . $file ) )
			{
				require_once( THIS_PATH . 'upg_' . $this->ipsclass->current_upgrade . '/' . strtolower($this->ipsclass->vars['sql_driver']) . $file );
		
				foreach( $UPDATES as $q )
				{
					$this->ipsclass->DB->query( $q );
					$cnt++;
				}
			}
			$this->ipsclass->core->redirect( "index.php?act=done&loginkey={$this->ipsclass->input['loginkey']}&securekey={$this->ipsclass->input['securekey']}&mid={$this->ipsclass->input['mid']}",
										 "$cnt   ...." );			
		}

	}
	
	
	/*-------------------------------------------------------------------------*/
	// Revert Skin Changes
	/*-------------------------------------------------------------------------*/
	
	function revert_skin_changes()
	{
		if(! $this->ipsclass->input['do_update'] )
		{
			$id = intval($this->ipsclass->input['skinid']) ? intval($this->ipsclass->input['skinid']) : 2;
			$default = $this->ipsclass->DB->simple_exec_query( array( 'select' => '*', 'from' => 'skin_sets', 'where' => "set_skin_set_id={$id}" ) );
			if( !$default['set_skin_set_id'] )
			{
				// Didn't find id 2, let's try by name
				$default = $this->ipsclass->DB->simple_exec_query( array( 'select' => '*', 'from' => 'skin_sets', 'where' => "set_name='IPB  '" ) );
				if( !$default['set_skin_set_id'] )
				{
					// Didn't find by name either
					$default = array();
				}
			}
			
			if( count( $default ) )
			{			
				$this->ipsclass->template->content .= "
								<div class='tableborder'>
			 					<div class='maintitle'>       (     )?</div>
			 					<div class='tdrow1' style='padding:6px'>        IPB  ,     .        ,        .   &laquo;IPB  &raquo;   .<br /><br />
			 					 ,    ,      ,  , ,   .         ,   ... ,    javascript ,      - ,         ... 
			 					<br /><br />
			 					          , ,       ,     .      ,     ,         ... 
			 				          &laquo;IPB 2.1  &raquo;   &laquo;  ......&raquo;   . ,       .<br /><br />
			 					-   HTML   ,         .  ,    ,      &laquo;   ...&raquo;     ,    .
			 					<br /><br /><b>        &laquo;{$default['set_name']}&raquo;?</b><br />(<i>    ,           </i>)
			 					<div align='left'><blockquote><span style='font-weight:bold;font-size:14px'>&raquo; <a href='{$this->base_url}&workact=skinrevert&do_update=1&man={$default['set_skin_set_id']}'>,      ...</a><br />
			 					&raquo; <a href='index.php?act=done&loginkey={$this->ipsclass->input['loginkey']}&securekey={$this->ipsclass->input['securekey']}&mid={$this->ipsclass->input['mid']}'>,      ...</a></span></blockquote></div>
					";
				}
				else
				{
					$this->ipsclass->template->content .= "<div class='warnbox'><strong>&laquo;IPB  &raquo;  </strong><br />
															     &laquo;IPB  &raquo;    (     ),     ,       .   &laquo;IPB  &raquo;   .</div>
															<br /><br />
															<div align='center'><span style='font-weight:bold;font-size:14px'>&raquo; <a href='index.php?act=done&loginkey={$this->ipsclass->input['loginkey']}&securekey={$this->ipsclass->input['securekey']}&mid={$this->ipsclass->input['mid']}'> ...</a></span></div>";
				}
			$this->ipsclass->template->output();
		}
		else
		{
			$man     = intval( $this->ipsclass->input['man'] );
			$cnt     = 0;
		
			$default = $this->ipsclass->DB->simple_exec_query( array( 'select' => '*', 'from' => 'skin_sets', 'where' => "set_skin_set_id=".$man ) );
			$this->ipsclass->DB->simple_construct( array( 'select' => '*', 'from' => 'skin_templates', 'where' => "set_id=".$man ) );
			$outer = $this->ipsclass->DB->simple_exec();
			
			if( $this->ipsclass->DB->get_num_rows($outer) )
			{
				while( $r = $this->ipsclass->DB->fetch_row($outer) )
				{
					if( $r['set_id'] == 1 )
					{
						continue;
					}
					else
					{
						$this->ipsclass->DB->simple_exec_query( array( 'delete' => 'skin_templates', 'where' => 'suid='.$r['suid'] ) );
						$cnt++;
					}
				}
			}
			
			$next = $this->ipsclass->DB->simple_exec_query( array( 'select' => '*', 'from' => 'skin_sets', 'where' => "set_skin_set_id>".$man, 'orderby' => 'set_skin_set_id ASC', 'limit' => array(0,1) ) );
			if( $next['set_skin_set_id'] )
			{
				$this->ipsclass->core->redirect( "index.php?act=work&workact=skinrevert&skinid={$next['set_skin_set_id']}&loginkey={$this->ipsclass->input['loginkey']}&securekey={$this->ipsclass->input['securekey']}&mid={$this->ipsclass->input['mid']}",
										 "$cnt    '{$default['set_name']}'     ...." );
			}
			else
			{
				$this->ipsclass->core->redirect( "index.php?act=done&loginkey={$this->ipsclass->input['loginkey']}&securekey={$this->ipsclass->input['securekey']}&mid={$this->ipsclass->input['mid']}",
										 "$cnt    '{$default['set_name']}'     ...." );			
			}
		}

	}		
	
	/*-------------------------------------------------------------------------*/
	// INTRO
	/*-------------------------------------------------------------------------*/
	
	function upgrade_intro()
	{
		$this->ipsclass->template->content .= "
			<div class='tableborder'>
			 <div class='maintitle'>     IPB</div>
			 <div class='tdrow1' style='padding:6px'>      <b>{$this->ipsclass->versions[$this->upgrade_from]}</b>  <b>{$this->ipsclass->versions[$this->this_version]}</b>
			 <br /><br />   {$this->first_step}
			 <br />
			";
			
		if ( ! is_writeable( CACHE_PATH . 'cache/skin_cache' ) )
		{
			$this->ipsclass->template->content .= "<div class='warnbox'><strong>:  cache/skin_cache   </strong><br />
					   ,  CHMOD   .     ,   
					     .</div>"; 
		}
		else
		{
			$this->ipsclass->template->content .= "<div align='center'><span style='font-weight:bold;font-size:14px'>&raquo; <a href='{$this->base_url}&workact=sql'> ...</a></span></div>
												   </div>
												  </div>
												  <br />
												  <div align='center'>    : {$this->mod_to_run}</div>";
		}
		
		$this->ipsclass->template->output();
		
	}
	
}
	
	
?>