<?php

/*
+--------------------------------------------------------------------------
|   Invision Power Board v2.1.6
|   ========================================
|   by Matthew Mecham
|   (c) 2001 - 2004 Invision Power Services
| http://www.ws.ea7.net & http://wowdesign.com.ua/
|   ========================================
| Web: http://www.ws.ea7.net & http://wowdesign.com.ua/
|   Time: Fri, 05 May 2006 13:32:48 GMT
|   Release: add887fd8a0e2e3eac2629adbeb403e5
|   Email: matt
| Licence Info: http://www.ws.ea7.net & http://wowdesign.com.ua/
+---------------------------------------------------------------------------
|
|   > IPB UPGRADE MODULE:: IPB 2.1.4 -> 2.1.5
|   > Script written by Matt Mecham
|   > Date started: 23rd April 2004
|   > "So what, pop is dead - it's no great loss.
	   So many facelifts, it's face flew off"
+--------------------------------------------------------------------------
*/

if ( ! defined( 'IN_IPB' ) )
{
	print "<h1> </h1>       .     ,      .";
	exit();
}  

class version_upgrade
{
	var $this_version = '21012';
	var $upgrade_from = '21011';
	var $first_step   = '         .';
	var $md5_check    = '';
	var $base_url     = '';
	var $mod_to_run   = '';
	
	/*-------------------------------------------------------------------------*/
	// CONSTRUCTOR
	/*-------------------------------------------------------------------------*/
	
	function version_upgrade()
	{

	}
	
	function version_process()
	{
		$this->md5_check = $this->ipsclass->return_md5_check();
		
		$this->base_url  = "index.php?act=work&loginkey={$this->ipsclass->input['loginkey']}&securekey={$this->ipsclass->input['securekey']}&mid={$this->ipsclass->input['mid']}";
		
		if ( is_array( $this->ipsclass->modules_to_run ) and count( $this->ipsclass->modules_to_run ) )
		{
			$tmp = array_shift( $this->ipsclass->modules_to_run );
			
			$this->mod_to_run = implode( ', ', $this->ipsclass->modules_to_run );
		}
		
		if ( ! $this->mod_to_run )
		{
			$this->mod_to_run = 'None';
		}
	}
	
	/*-------------------------------------------------------------------------*/
	// Auto run..
	/*-------------------------------------------------------------------------*/
	
	function auto_run()
	{
		
		
		//--------------------------------
		// What are we doing?
		//--------------------------------
		
		switch( $this->ipsclass->input['workact'] )
		{
			case 'sql':
				$this->upgrade_sql();
				break;
			case 'skinrevert':
				$this->revert_skin_changes();
				break;
			default:
				$this->upgrade_intro();
				break;
		}
	}
	
	
	/*-------------------------------------------------------------------------*/
	// SQL
	/*-------------------------------------------------------------------------*/
	
	function upgrade_sql()
	{
		$cnt = 0;
		$SQL = array();
		
		if ( file_exists( THIS_PATH.'upg_'.$this->ipsclass->current_upgrade.'/'.strtolower($this->ipsclass->vars['sql_driver']).'_updates.php' ) )
		{
			require_once( THIS_PATH.'upg_'.$this->ipsclass->current_upgrade.'/'.strtolower($this->ipsclass->vars['sql_driver']).'_updates.php' );
		
			foreach( $SQL as $q )
			{
				$this->ipsclass->DB->query( $q );
				
				$cnt++;
			}
		}
		
		//--------------------------------
		// Next page...
		//--------------------------------
		
		$this->ipsclass->core->redirect( "{$this->base_url}&workact=skinrevert", "$cnt  ...." );
		
	}
	
	
	/*-------------------------------------------------------------------------*/
	// Revert Skin Changes
	/*-------------------------------------------------------------------------*/
	
	function revert_skin_changes()
	{
		if(! $this->ipsclass->input['do_update'] )
		{
			$id = intval($this->ipsclass->input['skinid']) ? intval($this->ipsclass->input['skinid']) : 1;
			
			$default = $this->ipsclass->DB->simple_exec_query( array( 'select' => '*', 'from' => 'skin_sets', 'where' => "set_skin_set_id>{$id}" ) );
			
			if( !$default['set_skin_set_id'] )
			{
				if( $id > 2 )
				{
					$this->ipsclass->core->redirect( "index.php?act=done&loginkey={$this->ipsclass->input['loginkey']}&securekey={$this->ipsclass->input['securekey']}&mid={$this->ipsclass->input['mid']}",
														"    ...." );
				}
				else
				{
					$this->ipsclass->template->content .= "<div class='warnbox'><strong>  </strong><br />
															         ,  ,         , ,       .
															      .           ,        ..</div>
															<br /><br />
															<div align='center'><span style='font-weight:bold;font-size:14px'>&raquo; <a href='index.php?act=done&loginkey={$this->ipsclass->input['loginkey']}&securekey={$this->ipsclass->input['securekey']}&mid={$this->ipsclass->input['mid']}'> ...</a></span></div>";
				}
			}
			
			if( count( $default ) )
			{			
				$this->ipsclass->template->content .= "
								<div class='tableborder'>
			 					<div class='maintitle'>       (     )?</div>
			 					<div class='tdrow1' style='padding:6px'>        IPB  ,     .        ,        .   &laquo;IPB  &raquo;   .<br /><br />
			 					 ,    ,      ,  , ,   .         ,   ... ,    javascript ,      - ,         ... 
			 					<br /><br />
			 					          , ,       ,     .      ,     ,         ... 
			 				          &laquo;IPB 2.1  &raquo;   &laquo;  ......&raquo;   . ,       .<br /><br />
			 					-   HTML   ,         .  ,    ,      &laquo;   ...&raquo;     ,    . 
			 					<br /><br /><b>        &laquo;{$default['set_name']}&raquo;?</b><br />(<i>    ,           </i>)
			 					<div align='left'><blockquote><span style='font-weight:bold;font-size:14px'>&raquo; <a href='{$this->base_url}&workact=skinrevert&do_update=1&man={$default['set_skin_set_id']}&do=all'>,       ...</a><br />
			 					<span style='font-weight:bold;font-size:14px'>&raquo; <a href='{$this->base_url}&workact=skinrevert&do_update=1&man={$default['set_skin_set_id']}'>,       ...</a><br />
			 					&raquo; <a href='index.php?act=done&loginkey={$this->ipsclass->input['loginkey']}&securekey={$this->ipsclass->input['securekey']}&mid={$this->ipsclass->input['mid']}'>,      ...</a></span></blockquote></div>
					"; 
			}
			else
			{
				$this->ipsclass->template->content .= "<div class='warnbox'><strong>  </strong><br />
															         ,  ,         .</div>
															<br /><br /> 
															<div align='center'><span style='font-weight:bold;font-size:14px'>&raquo; <a href='index.php?act=done&loginkey={$this->ipsclass->input['loginkey']}&securekey={$this->ipsclass->input['securekey']}&mid={$this->ipsclass->input['mid']}'> ...</a></span></div>";
			}
			
			$this->ipsclass->template->output();
		}
		else
		{
			$man     = intval( $this->ipsclass->input['man'] );
			$cnt     = 0;
		
			$default = $this->ipsclass->DB->simple_exec_query( array( 'select' => '*', 'from' => 'skin_sets', 'where' => "set_skin_set_id=".$man ) );
			$this->ipsclass->DB->simple_construct( array( 'select' => '*', 'from' => 'skin_templates', 'where' => "set_id=".$man ) );
			$outer = $this->ipsclass->DB->simple_exec();
			
			if( $this->ipsclass->DB->get_num_rows($outer) )
			{
				while( $r = $this->ipsclass->DB->fetch_row($outer) )
				{
					if( $r['set_id'] == 1 )
					{
						continue;
					}
					else
					{
						$this->ipsclass->DB->simple_exec_query( array( 'delete' => 'skin_templates', 'where' => 'suid='.$r['suid'] ) );
						$cnt++;
					}
				}
			}
			
			$next = $this->ipsclass->DB->simple_exec_query( array( 'select' => '*', 'from' => 'skin_sets', 'where' => "set_skin_set_id>".$man, 'orderby' => 'set_skin_set_id ASC', 'limit' => array(0,1) ) );
			
			if( $next['set_skin_set_id'] )
			{
				if( $this->ipsclass->input['do'] == 'all' )
				{
					$this->ipsclass->core->redirect( "index.php?act=work&workact=skinrevert&do_update=1&do=all&man={$next['set_skin_set_id']}&loginkey={$this->ipsclass->input['loginkey']}&securekey={$this->ipsclass->input['securekey']}&mid={$this->ipsclass->input['mid']}",
										 	"$cnt    '{$default['set_name']}'     ,    ...." );					
				}
				else
				{
					$this->ipsclass->core->redirect( "index.php?act=work&workact=skinrevert&skinid={$man}&loginkey={$this->ipsclass->input['loginkey']}&securekey={$this->ipsclass->input['securekey']}&mid={$this->ipsclass->input['mid']}",
										 	"$cnt    '{$default['set_name']}'     ...." );
				}
			}
			else
			{
				$this->ipsclass->core->redirect( "index.php?act=done&loginkey={$this->ipsclass->input['loginkey']}&securekey={$this->ipsclass->input['securekey']}&mid={$this->ipsclass->input['mid']}",
										 "$cnt    '{$default['set_name']}'     ...." );			
			} 		}

	}			
	
	/*-------------------------------------------------------------------------*/
	// INTRO
	/*-------------------------------------------------------------------------*/
	
	function upgrade_intro()
	{
		$this->ipsclass->template->content .= "
			<div class='tableborder'>
			 <div class='maintitle'>     IPB</div>
			 <div class='tdrow1' style='padding:6px'>      <b>{$this->ipsclass->versions[$this->upgrade_from]}</b>  <b>{$this->ipsclass->versions[$this->this_version]}</b>
			 <br /><br />   {$this->first_step}
			 <br />
			";
			
		if ( ! is_writeable( CACHE_PATH . 'cache/skin_cache' ) )
		{
			$this->ipsclass->template->content .= "<div class='warnbox'><strong>:  cache/skin_cache   </strong><br />
					   ,  CHMOD   .     ,   
					     .</div>";  
		}
		else
		{
			$this->ipsclass->template->content .= "<div align='center'><span style='font-weight:bold;font-size:14px'>&raquo; <a href='{$this->base_url}&workact=sql'> ...</a></span></div>
												   </div>
												  </div>
												  <br />
												  <div align='center'>    : {$this->mod_to_run}</div>";
		}
		
		$this->ipsclass->template->output();
		
	}
	
}
	
	
?>