<?php
/*
+--------------------------------------------------------------------------
|   Invision Power Board v2.1.6
|   =============================================
|   by Matthew Mecham
|   (c) 2001 - 2005 Invision Power Services, Inc.
| http://www.ws.ea7.net & http://wowdesign.com.ua/
|   =============================================
| Web: http://www.ws.ea7.net & http://wowdesign.com.ua/
|   Time: Sun, 09 Oct 2005 11:51:26 GMT
|   Release: 1a47e28f0443faa9f14d0c0a45151e54
| Licence Info: http://www.ws.ea7.net & http://wowdesign.com.ua/
+---------------------------------------------------------------------------
|
|   > MODULE LOADER
|   > Module written by Matt Mecham
|   > Date started: Thu 14th April 2005 (17:55)
|
+--------------------------------------------------------------------------
| USAGE:
| ------
|
| This is a module loader file
| example: index.php?act=module&module=register&var=foo
| 
| Looks for a file called "mod_register.php" and runs it
|
+--------------------------------------------------------------------------
*/

class module_loader
{
	var $ipsclass;
	var $class;
	var $module;
	
	function run_loader()
	{
		$this->module = $this->ipsclass->txt_alphanumerical_clean($this->ipsclass->input['module']);
			
		if ( $this->module == "" )
		{
			$this->_return_dead();
		}
		
		//----------------------------------
		// Does module file exist?
		//----------------------------------
		
		if ( ! @file_exists( ROOT_PATH.'modules/mod_'.$this->module.'.php' ) )
		{
			$this->_return_dead();
		}
		
		//----------------------------------
		// Require and run
		//----------------------------------
		
		require_once( ROOT_PATH.'modules/mod_'.$this->module.'.php' );
		
		$mod_run           = new module();
		$mod_run->ipsclass =& $this->ipsclass;
		$mod_run->run_module();
		
		exit();
	}
	
	//------------------------------------------
	// _return_dead
	// 
	// Return to board index
	//
	//------------------------------------------
	
	function _return_dead()
	{
		global $ibforums;
		
		header("Location: ".$ibforums->base_url);
		
		exit();
	}
	
}


?>