<?php

/*
+---------------------------------------------------------------------------
|   Invision Power Dynamic v1.0.0
|   ========================================
|   by Matthew Mecham
|   (c) 2004 Invision Power Services
| http://www.ws.ea7.net & http://wowdesign.com.ua/
|   ========================================
+---------------------------------------------------------------------------
|   INVISION POWER DYNAMIC IS NOT FREE SOFTWARE!
| Web: http://www.ws.ea7.net & http://wowdesign.com.ua/
+---------------------------------------------------------------------------
|
|   > CONTROL PANEL (COMPONENTS) PAGES FILE
|   > Script written by Matt Mecham
|   > Date started: Tue. 15th February 2005
|
+---------------------------------------------------------------------------
*/

//===========================================================================
// Simple library that holds all the links for the admin cp
// THIS PAGE CLASS: Generate menu from DB
//===========================================================================


global $ipsclass;

$CATS  = array();
$PAGES = array();

//--------------------------------
// Get info from DB
//--------------------------------

foreach( $ipsclass->menu_components as $ix => $r )
{
	//--------------------------------
	// Process data
	//--------------------------------
	
	$menu_data = unserialize( $r['com_menu_data'] );
	$tmp_pages = array();
	
	//--------------------------------
	// First item is title...
	//--------------------------------
	
	$CATS[] = array( $r['com_title'] );
	
	//--------------------------------
	// Work through rest
	//--------------------------------
	
	if ( is_array( $menu_data ) and count( $menu_data ) )
	{
		foreach( $menu_data as $id => $menu )
		{
			if ( $menu['menu_text'] AND $menu['menu_url'] )
			{
				if ( $menu['menu_redirect'] )
				{
					$tmp_pages[] = array( $menu['menu_text'], $menu['menu_url'], "", 0, 1 );
				}
				else
				{
					$tmp_pages[] = array( $menu['menu_text'], 'section=components&amp;act='.$r['com_section'].'&amp;'.$menu['menu_url'] );
				}
			}
		}
	}
	
	$PAGES[] = $tmp_pages;
}

?>