<?php

/*
+--------------------------------------------------------------------------
|   Invision Power Board v2.1.6
|   ========================================
|   by Matthew Mecham
|   (c) 2001 - 2004 Invision Power Services
| http://www.ws.ea7.net & http://wowdesign.com.ua/
|   ========================================
| Web: http://www.ws.ea7.net & http://wowdesign.com.ua/
|   Time: Sun, 09 Oct 2005 11:51:26 GMT
|   Release: 1a47e28f0443faa9f14d0c0a45151e54
|   Email: matt
| Licence Info: http://www.ws.ea7.net & http://wowdesign.com.ua/
+---------------------------------------------------------------------------
|
|   > IPB UPGRADE MODULE:: IPB 2.0.0 PDR1 -> PDR 2
|   > Script written by Matt Mecham
|   > Date started: 23rd April 2004
|   > "So what, pop is dead - it's no great loss.
           So many facelifts, it's face flew off"
+--------------------------------------------------------------------------
*/

if ( ! defined( 'IN_IPB' ) )
{
        print "<h1> </h1>       .     ,      .";
        exit();
}

class version_upgrade
{
        var $this_version = '20006';
        var $upgrade_from = '20005';
        var $first_step   = '         .';
        var $md5_check    = '';
        var $base_url     = '';
        var $mod_to_run   = '';

        /*-------------------------------------------------------------------------*/
        // CONSTRUCTOR
        /*-------------------------------------------------------------------------*/

        function version_upgrade()
        {

        }

        function version_process()
        {


                $this->md5_check = $this->ipsclass->return_md5_check();

                $this->base_url  = "index.php?act=work&loginkey={$this->ipsclass->input['loginkey']}&securekey={$this->ipsclass->input['securekey']}&mid={$this->ipsclass->input['mid']}";

                if ( is_array( $this->ipsclass->modules_to_run ) and count( $this->ipsclass->modules_to_run ) )
                {
                        $tmp = array_shift( $this->ipsclass->modules_to_run );

                        $this->mod_to_run = implode( ', ', $this->ipsclass->modules_to_run );
                }

                if ( ! $this->mod_to_run )
                {
                        $this->mod_to_run = 'None';
                }
        }

        /*-------------------------------------------------------------------------*/
        // Auto run..
        /*-------------------------------------------------------------------------*/

        function auto_run()
        {


                //--------------------------------
                // What are we doing?
                //--------------------------------

                switch( $this->ipsclass->input['workact'] )
                {
                        case 'sql':
                                $this->upgrade_sql();
                                break;
                        default:
                                $this->upgrade_intro();
                                break;
                }
        }


        /*-------------------------------------------------------------------------*/
        // SQL
        /*-------------------------------------------------------------------------*/

        function upgrade_sql()
        {


                $cnt = 0;
                $sql = $this->_get_sql();

                foreach( $sql as $q )
                {
                        $this->ipsclass->DB->query( $q );

                        $cnt++;
                }

                //--------------------------------
                // Next page...
                //--------------------------------

                $this->ipsclass->core->redirect( "index.php?act=done&loginkey={$this->ipsclass->input['loginkey']}&securekey={$this->ipsclass->input['securekey']}&mid={$this->ipsclass->input['mid']}", "$cnt  ...." );

        }

        /*-------------------------------------------------------------------------*/
        // INTRO
        /*-------------------------------------------------------------------------*/

        function upgrade_intro()
        {


                $this->ipsclass->template->content .= "
                        <div class='tableborder'>
                         <div class='maintitle'>     IPB</div>
                         <div class='tdrow1' style='padding:6px'>      <b>{$this->ipsclass->versions[$this->upgrade_from]}</b>  <b>{$this->ipsclass->versions[$this->this_version]}</b>
                         <br /><br />   {$this->first_step}
                         <br /><br />
                         <div align='center'><span style='font-weight:bold;font-size:14px'>&raquo; <a href='{$this->base_url}&workact=sql'>...</a></span></div>
                         </div>
                        </div>
                        <br />
                        <div align='center'>    : {$this->mod_to_run}</div> ";

                $this->ipsclass->template->output();

        }

        /*-------------------------------------------------------------------------*/
        // SQL (ARRAY)
        /*-------------------------------------------------------------------------*/

        function _get_sql()
        {
                global $ibforums, $DB, $std;

                $SQL = array();

                if ( ! $this->ipsclass->DB->field_exists( 'subs_pkg_chosen', SQL_PREFIX.'members' ) )
                {
                        $SQL[] = "alter table ibf_members add subs_pkg_chosen smallint(3) NOT NULL default '0';";
                }

                $SQL[] = "alter table ibf_topic_mmod add topic_approve tinyint(1) NOT NULL default '0';";
                $SQL[] = "alter table ibf_groups add g_attach_per_post int(10) NOT NULL default '0';";
                $SQL[] = "INSERT INTO ibf_conf_settings_titles (conf_title_id, conf_title_title, conf_title_desc, conf_title_count, conf_title_noshow, conf_title_keyword) VALUES (23,'  (  )', '     .    .', 3, 1, 'subsmanager');";
                $SQL[] = "INSERT INTO ibf_conf_settings_titles (conf_title_id, conf_title_title, conf_title_desc, conf_title_count, conf_title_noshow, conf_title_keyword) VALUES (24,' IPB', '         IPB.', 3, 1, 'ipbreg');";
                $SQL[] = "INSERT INTO ibf_conf_settings_titles (conf_title_id, conf_title_title, conf_title_desc, conf_title_count, conf_title_noshow, conf_title_keyword) VALUES (25,'IPB  ', '        .', 2, 1, 'ipbcopyright');";
                $SQL[] = "INSERT INTO ibf_conf_settings_titles (conf_title_id, conf_title_title, conf_title_desc, conf_title_count, conf_title_noshow, conf_title_keyword) VALUES (20,' Invision Chat ( )', '       Invision Chat.', 14, 1, 'chat');";
                $SQL[] = "INSERT INTO ibf_conf_settings_titles (conf_title_id, conf_title_title, conf_title_desc, conf_title_count, conf_title_noshow, conf_title_keyword) VALUES (21,' Invision Chat', '     Invision Chat ( 2004+)', 10, 1, 'chat04');";

                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES (' &laquo;<&raquo;  &laquo;>&raquo;   &laquo;&raquo;  &laquo; &raquo;   ?', ' SMTP  ,  e-mail     .        ,   .', '12', 'yes_no', 'mail_wrap_brackets', '', '0', '', '', 1, 6, '', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('    ?', '      /    IPB.\r\n', '20', 'input', 'chat_account_no', '', '', '', '', 1, 1, '  ', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('  ?', '<!--SERVER-->', '20', 'input', 'chat_server_addr', '', '', '', '', 1, 2, '', 1, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES (' &#39;  ?&#39;', '   ,             ,     .', '20', 'yes_no', 'chat_who_on', '', '1', '', '', 1, 3, '  ', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES (' &laquo;  &raquo;,     ?', '', '20', 'yes_no', 'chat_hide_whoschatting', '', '1', '', '', 1, 4, '', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('    ,  :', '             .  .', '20', 'dropdown', '', '', '15', '5=5\r\n10=10\r\n15=15\r\n30=30', '', 1, 5, '', 1, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('    IPChat?', '        IPChat     .   ,   .', '20', 'input', 'chat_pass_md5', '', '', '', '', 1, 6, '', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('      IPCHAT', '        IPChat     &laquo;  &raquo;.', '20', 'input', 'chat_pass_md5_new', '', '', '', '', 1, 7, '', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('   ()?', '', '20', 'input', 'chat_width', '', '600', '', '', 1, 8, '  ', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('   ()?', '', '20', 'input', 'chat_height', '', '350', '', '', 1, 9, '', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('Pop-up     ? ( )', '     ', '20', 'input', 'chat_poppad', '', '50', '', '', 1, 10, '', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('    ?', '', '20', 'dropdown', 'chat_language', '', 'ru', 'en=English\r\nar=\r\nde=\r\nes=\r\nfr=\r\nhr=\r\nit=\r\niw=\r\nnl=\r\npl=\r\npt=', '', 1, 11, '', 1, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('   ...?', '', '20', 'dropdown', 'chat_display', '', 'self', 'self= IPB \r\nnew=   (Pop-Up)', '', 1, 9, '', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('      ', '   ,  ', '20', 'multi', 'chat_access_groups', '', '', '#show_groups#', 'if ( \$save == 1)\r\n{\r\n        if ( is_array(\$POST[\'chat_access_groups\']) )\r\n        {\r\n                \$POST[\'chat_access_groups\'] = implode(\",\",\$POST[\'chat_access_groups\']);\r\n        }\r\n        else\r\n        {\r\n                \$POST[\'chat_access_groups\'] = '';\r\n        }\r\n        \r\n        \$key = \'chat_access_groups\';\r\n}if ( \$show == 1 ) { \$key=\'chat_access_groups[]\'; }', 1, 13, ' ', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('    ', '   ,    ,  !', '20', 'multi', 'chat_admin_groups', '', '', '#show_groups#', 'if ( \$save == 1)\r\n{\r\n        if ( is_array(\$POST[\'chat_admin_groups\']) )\r\n        {\r\n                \$POST[\'chat_admin_groups\'] = implode(\",\",\$POST[\'chat_admin_groups\']);\r\n        }\r\n        else\r\n        {\r\n                \$POST[\'chat_admin_groups\'] = '';\r\n        }\r\n        \r\n        \$key = \'chat_admin_groups\';\r\n}if ( \$show == 1 ) { \$key=\'chat_admin_groups[]\'; }', 1, 14, '', 1, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('     ( )?', '      /    IPB.\r\n', '21', 'input', 'chat04_account_no', '', '', '', '', 1, 1, '  ', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('URL   ?', '<!--SERVER-->', '21', 'input', 'chat04_whodat_server_addr', '', 'http://invision.parachat.com/cgi-bin/userlist/test', '', '', 1, 2, '', 1, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES (' &#39;  ?&#39;', '   ,             ,     .', '21', 'yes_no', 'chat04_who_on', '', '1', '', '', 1, 3, '  ', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('Hide Who&#39;s Chatting when no members are logged into chat?', '', '21', 'yes_no', 'chat04_hide_whoschatting', '', '1', '', '', 1, 4, '', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('    ,  :', '             .  .', '21', 'dropdown', 'chat04_who_save', '', '1', '1=1\r\n5=5\r\n10=10\r\n15=15\r\n30=30', '', 1, 5, '', 1, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('   ()?', '', '21', 'input', 'chat04_width', '', '600', '', '', 1, 8, '  ', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('   ()?', '', '21', 'input', 'chat04_height', '', '350', '', '', 1, 9, '', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('Pop-up     ? ( )', '     ', '21', 'input', 'chat04_poppad', '', '50', '', '', 1, 10, '', 1, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('   ...?', '', '21', 'dropdown', 'chat04_display', '', 'self', 'self= IPB \r\nnew=  (Pop-Up)', '', 1, 9, '', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('      ', '   ,  ', '21', 'multi', 'chat04_access_groups', '', '', '#show_groups#', 'if ( \$save == 1)\r\n{\r\n        if ( is_array(\$POST[\'chat04_access_groups\']) )\r\n        {\r\n                \$POST[\'chat04_access_groups\'] = implode(\",\",\$POST[\'chat04_access_groups\']);\r\n        }\r\n        else\r\n        {\r\n                \$POST[\'chat04_access_groups\'] = '';\r\n        }\r\n        \r\n        \$key = \'chat04_access_groups\';\r\n}', 1, 13, ' ', 1, '', 1);";

                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('     ?', '5', 'yes_no', 'allow_creator_vote', '', '1', '', '', 1, 31, '', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('   ', '       ,         .\r\n<b>HTML </b>', '17', 'textarea', 'reg_rules', '', '<b>   </b>\r\n\r\n       ,  .         ,       &laquo;&raquo;.      &laquo;&raquo;   .\r\n\r\n ,        .\r\n\r\n        .      &#151;     .         ,  .        .\r\n\r\n  :\r\n     /,       ,  ,    ;   ;  ,    ..\r\n\r\n               .\r\n\r\n  ,      ,   ,      .\r\n', '', '', 1, 5, '   ', 1, '', 0);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('     ?', '   ,       ,      ...', '23', 'yes_no', 'subsm_show_reg', '', '1', '', '', 1, 1, '   ', 1, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('      ', '  ,      -    .', '23', 'yes_no', 'subsm_enforce', '', '0', '', '', 1, 2, 'Force Package Purchase', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES (' ,          ?', '   ,          ,     ...', '23', 'dropdown', 'subsm_nopkg_group', '', '1', '#show_groups#', '', 1, 3, '', 1, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('    ?', '      ?', '6', 'dropdown', 'reportpost_method', '', 'pm', 'email= email\r\npm= ', '', 1, 19, '', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('   ,     IPB?', '   ,          &#151; &laquo; : ...&raquo;.', '24', 'yes_no', 'ipb_reg_show', '', '0', '', '', 1, 2, '', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES (' &laquo; ...&raquo;', ':     Invision Power Services', '24', 'input', 'ipb_reg_name', '', '', '', '', 1, 3, '', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('IPB  ', '      ,    100%    ,   !', '24', 'input', 'ipb_reg_number', '', '', '', '', 1, 1, '', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES ('   IPB', '     IPB,   IPS.', '25', 'input', 'ipb_copy_number', '', '', '', '', 1, 1, '', 0, '', 1);";
                $SQL[] = "INSERT INTO ibf_conf_settings (conf_title, conf_description, conf_group, conf_type, conf_key, conf_value, conf_default, conf_extra, conf_evalphp, conf_protected, conf_position, conf_start_group, conf_end_group, conf_help_key, conf_add_cache) VALUES (' ?', '', '25', 'yes_no', 'ips_cp_purchase', '', '0', '', '', 1, 2, '', 0, '', 1);";

                return $SQL;
        }

}


?>
